local addonName = "Bartender3"

cyCircled_Bartender3 = cyCircled:NewModule(addonName)

function cyCircled_Bartender3:AddonLoaded(addon)
	self.db = cyCircled:AcquireDBNamespace(addonName)
	
	-- setup default config and element table (10 bars)
	local bid, bname = 0, ""
	self.defaultCfg = {}
	self.elements = {}
	self.buttonmap = {}
	for i=1, 10, 1 do
		self.defaultCfg["BT3Bar"..i] = true
		
		-- bars
		self.elements["BT3Bar"..i] = { 
			elements = {},
			args = {
				button = { width = 35, height = 35, },
				parentname = false,
			},
		}
		
		-- buttons (12 buttons per bar)
		bid = (i-1)*12
		for j=(bid+1), (bid+12) do
			bname = format("BT3Button%d", j)
			table.insert(self.elements["BT3Bar"..i].elements, bname)
			
			--  button to bar map (to easily check if a bar has the skin enabled)
			self.buttonmap[j] = i
		end
	end
	cyCircled:RegisterDefaults(addonName, "profile", self.defaultCfg)
	
	-- set bar style to "zoomed"
--	for _, v in pairs(Bartender3.actionbars) do
--		v.config.Style = "Zoomed"
--		v:RefreshStyle()
--	end
	
	-- catch style refresh and new created buttons
	self:Hook(Bartender3.Class.Bar.prototype, "RefreshStyle", "SetStyle")
	self:Hook(Bartender3.Class.Button.prototype, "CreateButtonFrame", "Update")
end

function cyCircled_Bartender3:GetElements()
	return {
		["BT3Bar1"] = true,
		["BT3Bar2"] = true,
		["BT3Bar3"] = true,
		["BT3Bar4"] = true,
		["BT3Bar5"] = true,
		["BT3Bar6"] = true,
		["BT3Bar7"] = true,
		["BT3Bar8"] = true,
		["BT3Bar9"] = true,
		["BT3Bar10"] = true,		
	}
end

function cyCircled_Bartender3:Update(obj)
	if not obj then return end
	
	self.hooks[Bartender3.Class.Button.prototype].CreateButtonFrame(obj)
	
	-- bar id
	local barid = self.buttonmap[obj.id]
	
	if not barid or not self.elements["BT3Bar"..barid] then return end
	if not self.db.profile["BT3Bar"..barid] then return end
	
	-- apply skin
	cyCircled:ApplySkin(self.elements["BT3Bar"..barid])
	cyCircled:ApplyColors(self.elements["BT3Bar"..barid])
end

function cyCircled_Bartender3:SetStyle(obj)
	if not obj then return end
	
	obj.config.Style = "Zoomed"
	self.hooks[Bartender3.Class.Bar.prototype].RefreshStyle(obj)
	
	-- apply skin
	cyCircled:ApplySkin(self.elements["BT3Bar"..obj.id])
	cyCircled:ApplyColors(self.elements["BT3Bar"..obj.id])
end
